/*	
*	Started by Cyan~Fire (cyan_fire@mindspring.com)
*	Version .1
*/

#include <stdio.h>
#include <string.h>
#include <windows.h>

#define B_LIMIT 256

char bpath[100];
char spath[100];

struct Bsetts		//Subbill.ini [Misc]
{
	bool newusers;	//AllowNewUsers
	char pw[100];	//BillingPassword
	int queue;		//MaxQueueForLogin
	int kdelay;		//KickoutDelay
	int port;		//Port

	void load();
} subbill;

struct Ssetts		//Server.ini [Billing] (unless otherwise specified)
{
	char ip[30];	//IP
	char pw[100];	//Password
	int bport;		//Port
	int groupid;	//GroupId
	int rtime;		//RecconectTime
	int atime;		//AttemptTime

	int mport;		//Misc:Port
	char level[50];	//Misc:DefaultLevelFile

	void load();
} server;

void Bsetts::load()
{
	newusers = (GetPrivateProfileInt("Misc", "AllowNewUsers", 0, bpath) != 0);
	GetPrivateProfileString("Misc", "BillingPassword", "-ERR-", pw, 100, bpath);
	queue = GetPrivateProfileInt("Misc", "MaxQueueForLogin", 0, bpath);
	kdelay = GetPrivateProfileInt("Misc", "KickOutDelay", 0, bpath);
	port = GetPrivateProfileInt("Misc", "Port", 0, bpath);
}

void Ssetts::load()
{
	GetPrivateProfileString("Billing", "IP", "-ERR-", ip, 30, spath);
	GetPrivateProfileString("Billing", "Password", "-ERR-", pw, 100, spath);
	bport = GetPrivateProfileInt("Billing", "Port", 0, spath);
	groupid = GetPrivateProfileInt("Billing", "GroupId", 0, spath);
	rtime = GetPrivateProfileInt("Billing", "ReconnectTime", 0, spath);
	atime = GetPrivateProfileInt("Billing", "AttemptTime", 0, spath);

	mport = GetPrivateProfileInt("Misc", "Port", 0, spath);
	GetPrivateProfileString("Misc", "DefaultLevelFile", "-ERR-", level, 100, spath);
}

int main()
{
	GetCurrentDirectory(B_LIMIT, bpath);
	strcat(bpath, "\\subbill.ini");
	GetCurrentDirectory(B_LIMIT, spath);
	strcat(spath, "\\server.ini");

	subbill.load();
	server.load();
	bool error = false;
	if (!subbill.newusers)
	{
		printf("Set AllowNewUsers=1\n");
		WritePrivateProfileString("Misc", "AllowNewUsers", "1", bpath);
		error = true;
	}
	if (strcmp(subbill.pw, server.pw) != 0)
	{
		printf("Billing password mismatch. Set to %p.\n", *subbill.pw);
		WritePrivateProfileString("Billing", "Password", subbill.pw, spath);
		error = true;
	}
	if (subbill.queue <= 0)
	{
		printf("Set MaxQueueForLogin=1\n");
		WritePrivateProfileString("Misc", "MaxQueueForLogin", "1", bpath);
		error = true;
	}
	if (subbill.kdelay < 1000)
	{
		printf("Set KickOutDelay=60000\n");
		WritePrivateProfileString("Misc", "KickOutDelay", "60000", bpath);
		error = true;
	}
	if (subbill.port != server.bport || server.bport == server.mport)
	{
		char port[10];
		itoa(subbill.port, port, 10);
		printf("Billing port error. Set to %p\n", subbill.port);
		WritePrivateProfileString("Billing", "Port", port, spath);
		error = true;
	}
	if (strcmp(server.ip, "localhost") != 0)
	{
		printf("Billing IP set to \'localhost\'\n");
		WritePrivateProfileString("Billing", "IP", "localhost", spath);
		error = true;
	}
	if (server.groupid < 1)
	{
		printf("Invalid group ID. Set to 1.\n");
		WritePrivateProfileString("Billing", "GroupId", "1", spath);
		error = true;
	}
	if (strcmp(server.level, "") == 0)
	{
		printf("Missing DefaultLevelFile. Please set one.\n");
		error = true;
	}
	if (error)
		printf("\nPlease record the above errors for future reference.");
	else
		printf("Congratulations, your INIs had no routine errors!");
	printf("\nPress ENTER to exit.\n");
	getchar();
	return 0;
}